#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include "config.h"

/*
Esercizio2
	un programmino di esempio sull'uso delle pipe e le configurazioni
	client/server in C

client_pipe.c
	programma client, non fa altro che determinare il suo pid, creare
	una pipe privata (con una convenzione nota al server), scrivere una
	stringa nella sintassi gia` vista e aspettare l'output.

Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/


// devo anche commentarla?! ;)
void help (void) {

printf ("client_pipe, spara un comando alla pipe\n\n");
printf ("client_pipe comes with ABSOLUTELY NO WARRANTY;\n");
printf ("This is free software, and you are welcome to redistribute it\n");
printf ("under certain conditions; see GNU GPL version 2 or above for detail\n\n");
printf ("USO:\tclient_pipe comando\n\n");
printf ("\tcomando\te` un comando valido accettato dal server\n");
printf ("\t\tprovate per sapere quali sono i comandi validi ;)\n\n");
printf ("Report bug to gaio@dei.unipd.it");

}


void main( int argc, char *argv[]) {

pid_t	pid;		// il mio PID
char	pname[PNLEN],	// nome della pipe privata da creare
	cmd[CLEN],	// comando
	buf[BUFLMAX],	// buffer per la stringa per il server
	b;		// per il cat
int	spfd;		// master pipe file descriptor


// un po' di controlli sui parameti passati...
if ( argc != 2) {
	help();
	printf("\nnumero di parametri errato\n");
	exit(OERR);
} else 	sprintf(cmd, "%s", argv[1]);
#ifdef DEBUG
	printf("client: comando e`: %s\n",cmd);
#endif



// Chi sono io?!
pid = getpid();
// costruisco il path della pipe privata (client)
sprintf(pname, "%s%s%u", PNAME, ".", pid);
#ifdef DEBUG
	printf ("client: mio pid e`: %u, pipe privato %s\n", pid,pname);
#endif

// creo il comando
sprintf(buf,"%u%s%s%s",pid, " # ", cmd, " #    ");


// Orbene, ho tutto quello che mi serve, devo solo creare una nuova pipe
// tutta per me
if ( mknod(pname, PMODE | S_IFIFO, 0) == -1 ) {
	perror("client_pipe: errore creando il pipe privato");
	exit(CDERR);
}
#ifdef DEBUG
	printf("client: pipe privata creata\n");
#endif


// Ora apriamo il master pipe
// questo ``sblocca'' il master pipe che e` fermo sulla open
if ( (spfd = open(PNAME, O_WRONLY)) == -1 ) {
	perror("client_pipe: errore aprendo il pipe");
	exit(OCERR);
}
#ifdef DEBUG
	printf("client: master pipe aperta, FD=%u\n",spfd);
#endif


// ora scrivo nel pipe la stringa di comando...
if ( write(spfd, &buf, sizeof(buf)) != sizeof(buf) ){
	perror("client_pipe: errore scrivendo sul pipe");
	exit(RWERR);
}
#ifdef DEBUG
	printf("client: scritto comando nella master pipe e chiuso\n");
	printf("client: comando: %s\n", buf);
#endif


// ora io mi blocco ad aspettare dati dal server
close(STDIN);
if ( open(pname, O_RDONLY) != STDIN ) {
	perror("client_pipe: errore aprendo il pipe privato");
	exit(OCERR);
}
#ifdef DEBUG
	printf("client: pipe privata aperta RO\n");
#endif

// se passo questo vuol dire che il server ha iniziato a scrivere, bene,
// chiudo e libero il server stesso
close (spfd);


// leggo quello che mi arriva... non sto fisicamente leggendo da disco
// quindi mi posso permettere questo stupidissimo for che in una lettura
// da disco pianterebbe un cray... ;)))
while ( read(STDIN, &b, sizeof(b)) > 0 ) {
	write(STDOUT,&b,sizeof(b));
}

// un po' di pulizia, non devo fare altro...
close(STDIN);
if ( unlink(pname) == -1 ) {
	perror("client_pipe: errore rimuovendo il pipe privato");
	exit(CDERR);
}
#ifdef DEBUG
	printf("client: pipe privata chiusa\n");
#endif

} // main()