#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include "config.h"

/*
Esercizio2
	un programmino di esempio sull'uso delle pipe e le configurazioni
	client/server in C

server_pipe-wrapper.c
	semplice wrapper che permette di eliminare la pipe se il server
	reale muore per qualche motivo.

Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/


void main(void) {

int 	s;	// stato di ritorno


printf("server_pipe: partito\n");

// creo la pipe
if ( mknod(PNAME, PMODE | S_IFIFO, 0) < 0) {
	perror("server_pipe-wrapper: errore creando il pipe");
	exit(CDERR);
}
#ifdef DEBUG
	printf("server: master pipe creata\n");
#endif


// non devo fare molto, solo una fork/wait per il vero server...
switch ( fork() ) {

case 	-1:	// errore!

	perror("server_pipe-wrapper: errore facendo fork");
	exit(FWERR);

case	0:	// figlio: eseguo il server vero

	server_pipe();

default:	// il padre: aspetto la morte del server...

	wait(&s);

} // switch

// rimetto a posto tutto...
if ( unlink(PNAME) < 0 ) {
	perror("server_pipe-wrapper: errore rimuovendo il pipe");
	exit(CDERR);
}

printf("server_pipe: terminato, master pipe rimossa\n");
exit(s);

} /* end main() */
